//
//  QBChatModule+Messages.h
//  crossplatform-sdk
//
//  Created by Injoit on 26.12.2019.
//  Copyright © 2019 Injoit LTD. All rights reserved.
//

#import "QBChatModule.h"

NS_ASSUME_NONNULL_BEGIN

@interface QBChatModule (Messages)

@property (nonatomic, strong, readonly) NSMutableSet<NSString *> *messageListenersIDs;
@property (nonatomic, strong, readonly) NSMutableSet<NSString *> *statusListenersIDs;

- (void)getDialogMessages:(NSDictionary *)info
                 resolver:(QBResolveBlock)resolve
                 rejecter:(QBRejectBlock)reject;

- (void)sendMessage:(NSDictionary *)info
           resolver:(QBResolveBlock)resolve
           rejecter:(QBRejectBlock)reject;

- (void)sendSystemMessage:(NSDictionary *)info
                 resolver:(QBResolveBlock)resolve
                 rejecter:(QBRejectBlock)reject;

- (void)markMessageRead:(NSDictionary *)info
               resolver:(QBResolveBlock)resolve
               rejecter:(QBRejectBlock)reject;

- (void)markMessageDelivered:(NSDictionary *)info
                    resolver:(QBResolveBlock)resolve
                    rejecter:(QBRejectBlock)reject;

- (void)subscribeMessageEvents:(NSDictionary *)info
                      resolver:(QBResolveBlock)resolve
                      rejecter:(QBRejectBlock)reject;

- (void)unsubscribeMessageEvents:(NSDictionary *)info
                        resolver:(QBResolveBlock)resolve
                        rejecter:(QBRejectBlock)reject;

- (void)subscribeMessageStatus:(NSDictionary *)info
                      resolver:(QBResolveBlock)resolve
                      rejecter:(QBRejectBlock)reject;

- (void)unsubscribeMessageStatus:(NSDictionary *)info
                        resolver:(QBResolveBlock)resolve
                        rejecter:(QBRejectBlock)reject;

@end

@interface QBChatModule (MessageProtocol) <QBChatReceiveMessageProtocol>
@end

NS_ASSUME_NONNULL_END
